![Logo](https://github.com/iotoasis/SO/blob/master/logo_oasis_m.png)

# Oasis Project

본 Oasis (Open-source Architecture Semantic Iot Service-platform) 프로젝트는 국제 표준을 준용하는 오픈 소스 기반 지능형 사물 인터넷 서비스 플랫폼을 개발하는 것을 목표로 하고 있습니다.

본 Oasis 프로젝트는 2015년도 정보통신․방송 기술개발사업 신규지원 대상과제 "(ICBMS-3세부) 사물 가상화, 분산 자율지능 및 데이터 연계/분석을 지원하는 IoT 기반 플랫폼 기술 개발" 과제의 결과물로써 오픈소스로 제공됩니다.

본 Oasis 프로젝트는 오픈 소스 커뮤니티를 기반으로 오픈소스로써 계속적으로 성장해 나갈 계획입니다.

# SDA (Semantic Data Analysis)
 SDA는 IoT 환경에서 발생하는 센서/디바이스 데이터, 레거시 데이터를 수집, 분석, 제공하는 기능을 지원하는 데이터 분석 프레임워크 입니다. 
 
## 주요기능

* OneM2M 표준 플랫폼 기반 데이터 수집
* RDF/OWL 등 시맨틱 웹 표준 준수
* Semantic Annotation
* 센서네트워크 온톨로지(SSNO), 상황인지(DUL) 등 IoT 도메인 전용 레퍼런스 모델 적용
* 실시간 상황인지를 위한 추론 기능

## Documents
 - [Quick Start](./sda-doc/quick-start.md)
 - [SDA 설정방법](./sda-doc/configuration.md)
 - [SDA Build 방법](./sda-doc/build_eclipse.md)

## Downloads
 - [릴리즈 페이지](https://github.com/iotoasis/SDA/releases)
 
## Modules
- SDA Framework는 세개의 서버 모듈로 구성됩니다.<br> 
-- sda-client :  독립적으로 실행되는 client프로그램을 가지고 있는 모듈<br>
-- sda-common : sda의 core모듈로 공통적인 기능과 core기능을 포함하고 있는 모듈<br>
-- sda-web : RESTFul API및 web서비스등을 제공하기 위한 web 모듈
<br>

